package cn.iocoder.yudao.module.pms.service.iotdailyreportattrs;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotdailyreportattrs.vo.IotDailyReportAttrsPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotdailyreportattrs.vo.IotDailyReportAttrsSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotdailyreportattrs.IotDailyReportAttrsDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotdailyreportattrs.IotDailyReportAttrsMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DAILY_REPORT_ATTRS_NOT_EXISTS;

/**
 * 日报扩展模板属性 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotDailyReportAttrsServiceImpl implements IotDailyReportAttrsService {

    @Resource
    private IotDailyReportAttrsMapper iotDailyReportAttrsMapper;

    @Override
    public Long createIotDailyReportAttrs(IotDailyReportAttrsSaveReqVO createReqVO) {
        // 插入
        IotDailyReportAttrsDO iotDailyReportAttrs = BeanUtils.toBean(createReqVO, IotDailyReportAttrsDO.class);
        iotDailyReportAttrsMapper.insert(iotDailyReportAttrs);
        // 返回
        return iotDailyReportAttrs.getId();
    }

    @Override
    public void updateIotDailyReportAttrs(IotDailyReportAttrsSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDailyReportAttrsExists(updateReqVO.getId());
        // 更新
        IotDailyReportAttrsDO updateObj = BeanUtils.toBean(updateReqVO, IotDailyReportAttrsDO.class);
        iotDailyReportAttrsMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDailyReportAttrs(Long id) {
        // 校验存在
        validateIotDailyReportAttrsExists(id);
        // 删除
        iotDailyReportAttrsMapper.deleteById(id);
    }

    private void validateIotDailyReportAttrsExists(Long id) {
        if (iotDailyReportAttrsMapper.selectById(id) == null) {
            throw exception(IOT_DAILY_REPORT_ATTRS_NOT_EXISTS);
        }
    }

    @Override
    public IotDailyReportAttrsDO getIotDailyReportAttrs(Long id) {
        return iotDailyReportAttrsMapper.selectById(id);
    }

    @Override
    public PageResult<IotDailyReportAttrsDO> getIotDailyReportAttrsPage(IotDailyReportAttrsPageReqVO pageReqVO) {
        return iotDailyReportAttrsMapper.selectPage(pageReqVO);
    }

    @Override
    public List<IotDailyReportAttrsDO> getIotDailyReportAttrs(IotDailyReportAttrsPageReqVO pageReqVO) {
        return iotDailyReportAttrsMapper.dailyReportAttrs(pageReqVO);
    }

}